这是一道贪心题,贪心的策略是将大臣们按左右手金币的乘积升序排列,具体证明过程可以参见洛谷大佬的题解,这里就不再赘述了。
因为本菜鸡之前没有接触过高精度运算,对C++的运算符重载也不太熟练,所以正好借此机会记录一下用到的高精度模版。模版框架参考于:https://blog.csdn.net/Wall_F/article/details/8373395
然而,直接复制该模版会导致TLE,原因在于这道题只需要高精度乘(除)低精度即可,但模版的乘除法运算是支持双高精度的,依赖于高精度的加减法,算法更加复杂,对于这道题来说增加了不必要的时间开销。所以我们需要把乘除法修改一下,删除高精度加减法的部分,得到如下简化版的代码,并顺利AC。
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
using namespace std;
const int MAXN = 10010;
struct bign
{
int len, s[MAXN];
bign ()
{
memset(s, 0, sizeof(s));
len = 1;
}
bign (int num) { *this = num; }
bign (const char *num) { *this = num; }
bign operator = (const int num)
{
ch